/*************************************************************************/
/* Nom : fichier couleur.h                                               */
/*                                                                       */
/* Role : Definition des couleurs des differents ecrans                  */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 08/04/1997 | Creation du fichier                                */
/*     |            |                                                    */
/* PDB | 20/04/1997 | Ajout des couleurs pour le mode initiation         */
/*     |            |                                                    */
/* PDB | 02/05/1997 | Ajout des couleurs pour les regles du jeu          */
/*     |            |                                                    */
/*************************************************************************/


/********************************************************/
/* Definition des couleurs utilisees pour les dialogues */
/********************************************************/



/* Couleurs utilisees pour representer un bouton                            */
/* Nota : ces couleurs sont utilisees pour dessiner les boites de dialogues */


/* +----------------+-+ */
/* |   BORD1        | | */
/* | +------------+-+ | */
/* | | FOND       | | | */
/* | |            | | | */
/* | |            | | | */
/* | |            | | | */
/* | |            | | | */
/* | +------------+ | | */
/* | | BORD2        | | */
/* +-+--------------+ | */
/* |   BORD3          | */
/* +------------------+ */

#ifdef PAT

#define BORD1		10 /* couleur gris clair */
#define BORD2		56 /* couleur gris fonce */
#define BORD3		 0 /* couleur noir */
#define FOND		20 /* couleur gris */

#define BORD1		23 /* couleur  */
#define BORD2		80 /* couleur  */
#define BORD3		 0 /* couleur noir */
#define FOND		29 /* couleur */

#endif

#define BORD1		23 /* couleur bleu clair */
#define BORD2		80 /* couleur bleu fonce */
#define BORD3		 0 /* couleur noir */
#define FOND		29 /* couleur bleu */

/* Couleur du texte */

#define TEXTE		 0 /* couleur du texte -> Noir */
#define TEXTE_FOND	 2 /* couleur du fond en blanc si on desire un fond different */
#define TEXTE_INACTIF	56 /* couleur gris fonce */

#define TEXTE_NOM       32 /* couleur orange */

#define TEXTE_SCORE    56 /* 243 couleur mettant en evidence le meilleur score */

/* Couleur initiation */
#define COULEUR_NOIR     0 /* couleur noire */
#define COULEUR_BLANC    2 /* couleur blanche */
#define DAMIER          44 /* couleur du damier */

/* couleur pour les regle du jeu */
#define REGLES_BORD1	       228 /* couleur gris clair */
#define REGLES_BORD2	       220 /* couleur gris fonce */
#define REGLES_BORD3		 0 /* couleur noir */
#define REGLES_FOND	       224 /* couleur gris */
