/* prototyp.h - function declarations */

/* Copyright 1997-2001 Otho team. */

/*
modification history
--------------------
15a,21oct01,pdb  based on Otho version 1.4b.
*/

/* includes */

#ifndef __INCprototyph
#define __INCprototyph

#include "include\svgacc.h"
#include "include\type.h"

/* protoypage des fonctions du fichier keyboard.c */

extern unsigned int getkey (void);

/* prototypage des fonctions du fichier memoire.c */

extern void allocation_memoire (void);
extern void libere_memoire     (void);


/* prototypage des fonctions du fichier materiel.c */

extern void materiel (void);

/* prototypage des fonctions du fichier services.c */

extern void attente            (int);
extern void erreur_application ( char *, char *, int );

/* prototypage des fonctions du fichier video.c */

extern void depart_video (void);
extern void video_on     (void);
extern void video_off    (void);
extern void loadpal      (PaletteData , int);
extern void charge_image (char *, int);


/* prototypage des fonctions du fichier ecran1.c */

extern void ecran_presentation (void);

/* prototypage des fonctions du fichier souris.c */

extern void change_curseur        (int);
extern void mouse_attente         (void);
extern void mouse_attente_relache (void);
extern char mouse_zone            (int, int, int, int);
extern void mouse_visible         (char);

/* prototypage des fonctions du fichier variable.c */

extern void initialise_variables (void);

/* prototypage des fonctions du fichier menupal.c */

extern void menu_principal (void);
extern void affiche_choix  (char, char);

/* prototypage des fonctions du fichier jouer.c */

extern void jouer          		 (int);
extern void initialise_ecran_jeu        (void);
extern void initialise_objet_graphique  (void);
extern void initialise_jeu 		 (void);
extern void initialise_tableau_commande (void);
extern void compte_pions   		 (void);
extern void raz_zone_score 		 (void);
extern void affiche_nombre 		 (int, int, int);
extern void affiche_pions  	         (void);
extern int  choix_joueur   		 (void);
extern void change_joueur  		 (void);
extern void jouer_coup     		 (char, char, int);
extern void coup_precedent		 (void);
extern void coup_suivant		 (void);
extern void memorise_jeu		 (int);
extern void conseil_coup		 (int);
extern void jeu_normal                  (void);


/* prototypage des fonctions du fichier 2joueur.c */

extern void jeu_2joueurs (char);
extern void fin_jeu      (void);

/* prototypage des fontions du fichier algorith.c */

extern char retourne                 (char [10][10], char, char, char, int);
extern int  evaluation_damier        (char [10][10]);
extern void ordinateur_debutant      (int);
extern void ordinateur_intermediaire (int);
extern void ordinateur_expert        (int, int);
extern void min_max                  (char [10][10], int, int, char *, char *, int *);
extern void alpha_beta               (char [10][10], int, int, char *, char *, int *, int, int);


/* prototypage des fontions du fichier dialogue.c */

extern void dialogue_boite           (int, int, int, int);
extern void dialogue_cadre           (int, int, int, int);
extern void dialogue_zone_saisie     (int, int, int, int);
extern void dialogue_bouton_relache  (int, int, int, int);
extern void dialogue_bouton_appuye   (int, int, int, int);
extern void dialogue_OK              (int, int, int, int);
extern void dialogue                 (char *);
extern char dialogue_type_jeu        (void);
extern char dialogue_gere_choix      (void);
extern void dialogue_etat_choix      (void);
extern void dialogue_aide_en_ligne   (char *);
extern int  dialogue_choix_couleur   (void);
extern int  dialogue_OK_couleur      (int, int, int, int);
extern void dialogue_passe_tour      (int);
extern char dialogue_OK_Annuler      (int, int, int, int);
extern char dialogue_saisie          (char *, char *, char);
extern char dialogue_gestion_clavier (void);



/* prototypage des fontions du fichier ordinat.c */

extern void ordinateur_vs_ordinateur ( char );

/* prototypage des fontions du fichier apropos.c */

extern void apropos ( void );

/* prototypage des fontions du fichier initiat.c */

extern void initiation   ( void );
extern void affiche_coup ( int, char );
extern int coup_possibles (char board[10][10], typeStructureCoups possibles[NOMBRE_COUPS],int joueurCourant);

/* prototypage des fontions du fichier statist.c */

extern void statistique                (int);
extern void statistique_affiche        (int, int, int);
extern void statistique_affiche_donnee (int, int, char *, int);

/* prototypage des fontions du fichier regles.c */

extern void regles		    ( void );
extern void regles_affiche_boutons ( void );
extern void regles_affiche         ( char );
extern void regles_bouton_relache  ( int, int, int ,int);
extern void regles_bouton_appuye   ( int, int, int ,int);

/* prototypage des fontions du fichier fichier.c */

extern void sauve_partie  ( void );
extern char charge_partie ( char * );

/* prototypage des fontions du fichier visual.c */

extern void visualiser ( void );

/* prototypage des fontions du fichier scores.c */

extern void high_score         ( void );
extern void affiche_high_score ( char );
extern void sauve_score        ( void );
extern char charge_score       ( void );

/* prototypage des fontions du fichier ouvert.c */

extern void ouverture           ( void );
extern void ouverture_visualise ( int  );
extern char prepare_ouverture   ( void );
// void creation_bibliotheque_ouverture ( FILE *, FILE *);
// char affiche_page_ouverture ( char, FILE * );
// char ouverture_gestion_souris ( int, FILE * );
extern char selection_ouverture ( void );

/* prototypage des fontions du fichier temps.c */

extern void affiche_temps   ( int );
extern void debut_reflexion ( void );
extern void fin_reflexion   ( int );
extern void gere_reflexion  ( void );

/* prototypage des fonctions du fichier capture.c */

extern void capture_ecran ( void );

/* prototypage programme principal */

extern void main ( int, char ** );

#endif /* __INCprototyph */
