/*************************************************************************/
/* Nom : jeu_2joueur                                                     */
/*                                                                       */
/* Role : Fonction permettant de jouer  deux joueurs (HUMAIN/ORDINATEUR)*/
/*                                                                       */
/*                                                                       */
/* Entree : -                                                            */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 30/01/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/* PDB | 06/04/1997 | Evolution de l'environnement de jeu                */
/*     |            |                                                    */
/* PDB | 20/04/1997 | Mise en place des boutons precedent, suivant et    */
/*     |            | conseil                                            */
/*     |            |                                                    */
/* PDB | 06/05/1997 | Mise en place de la reprise d'une ancienne partie  */
/*     |            |                                                    */
/* PDB | 18/05/1997 | Mise en place de la gestion des highs scores       */
/*     |            |                                                    */
/* PDB | 21/05/1997 | Deport de le gestion d'une reprise de partie       */
/*     |            |                                                    */
/* PDB | 21/06/1997 | Ajout de la gestion du temps                       */
/*     |            |                                                    */
/* PDB | 29/06/1997 | Modification du principe de saisie des noms        */
/*     |            |                                                    */
/* PDB | 30/06/1997 | Lors de la saisie des noms de joueurs, le clic sur */
/*     |            | Annuler revient au dialogue de choix du type de jeu*/
/*     |            |                                                    */
/*************************************************************************/

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "include\svgacc.h"

#include "include\prototyp.h"
#include "include\global.h"
#include "include\couleur.h"

void jeu_2joueurs ( char reprise )
{
	char finJeu     = FALSE; /* drapeau indiquant la fin du jeu */
//	char clicStop   = FALSE; /* clique sur le bouton STOP */
	char afficheCoup = FALSE; /* affichage des coups possibles */
	char coupOrdinateur = TRUE;  /* coup suivant a jouer par l'ordinateur */
	int  nombrePion = 0;     /* nombre de pions places sur le damier */
	char caseX, caseY ;      /* emplacement du pion sur le damier */
	int  profondeur;         /* profondeur de la recherche du meilleur coup */
	char bouton;

	char buffer[MAX_BUFFER]; /* chaine tamporaire */

	char lettres [9][2] = {" ", "A", "B", "C", "D", "E", "F", "G", "H"};
	char chiffres[9][2] = {" ", "1", "2", "3", "4", "5", "6", "7", "8"};


	if (reprise == NOK) /* partie inexistante */
	{
		/* saisie des noms de joueurs humains */
		switch (G_ordinateur)
		{
			case VIDE : /* Humain contre Humain */
				    bouton = dialogue_saisie("NOIR, entrez votre nom", G_nomMemorise[NOIR], 10);
				    if (bouton == OK)
				    {
					    strcpy(G_nom[NOIR], G_saisie.chaine);
					    strcpy(G_nomMemorise[NOIR], G_nom[NOIR]);
				    }
				    else return;

				    bouton = dialogue_saisie("BLANC, entrez votre nom", G_nomMemorise[BLANC], 10);
				    if (bouton == OK)
				    {
					    strcpy(G_nom[BLANC], G_saisie.chaine);
					    strcpy(G_nomMemorise[BLANC], G_nom[BLANC]);
				    }
				    else return;
				    break;

			case NOIR :
				    bouton = dialogue_saisie("BLANC, entrez votre nom", G_nomMemorise[BLANC], 10);
				    if (bouton == OK)
				    {
					    strcpy(G_nom[BLANC], G_saisie.chaine);
					    strcpy(G_nomMemorise[BLANC], G_nom[BLANC]);
				    }
				    else return;

				    sprintf(G_nom[NOIR], "OTHO NOIR");

				    break;
			case BLANC:
				    bouton = dialogue_saisie("NOIR, entrez votre nom", G_nomMemorise[NOIR], 10);
				    if (bouton == OK)
				    {
					    strcpy(G_nom[NOIR], G_saisie.chaine);
					    strcpy(G_nomMemorise[NOIR], G_nom[NOIR]);
				    }
				    else return;

				    sprintf(G_nom[BLANC], "OTHO BLANC");

				    break;
		}
	}

	/* affichage des Noms des joueurs */
	drwstring(1, TEXTE_NOM, FOND, G_nom[NOIR],   20+(90-strlen(G_nom[NOIR])*8)/2, 75);
	drwstring(1, TEXTE_NOM, FOND, G_nom[BLANC], 530+(90-strlen(G_nom[BLANC])*8)/2, 75);


	if (reprise == NOK)
	{
		/* debut du jeu */
		dialogue_aide_en_ligne("C'est au joueur NOIR de commencer.");
		statistique(NOIR);
	}
	else /* affichage du dernier coup joue */
	{
		G_jeuIndiceCrt = G_jeuIndiceMax - 1;
		coup_suivant();

		if ((G_joueurCourant != G_ordinateur) || (G_jeuIndiceMax == NOMBRE_COUPS))
			coupOrdinateur = FALSE;

		/* affichage du dernier temps */
		affiche_temps(NOIR);
		affiche_temps(BLANC);

		/* raz aide en ligne */
		dialogue_aide_en_ligne("Reprise ancienne partie");

	}


	/* On verifie si on est en initiation */
	if (G_ordinateur != VIDE && G_choixTypeJeu[G_ordinateur-1] == 0)
		afficheCoup = TRUE;


	/* Tant que l'on ne quitte pas le jeu */
	do
	{
		/* tableau de commande a l'etat normal */
		initialise_tableau_commande();

		/* Est-ce que c'est a l'ordinateur de jouer ? */
		if (G_ordinateur == G_joueurCourant && coupOrdinateur)
		{
			coupOrdinateur = FALSE;

			/* mise en place des temps de jeu */
			debut_reflexion();

			switch(G_choixTypeJeu[G_ordinateur-1])
			{

				case 0: /* niveau initiateur */
					profondeur = 0;
					G_statistique[G_ordinateur].profondeur = profondeur;
					ordinateur_debutant(G_ordinateur);
					afficheCoup = TRUE;
					break;

				case 1: /* niveau dbutant */
					profondeur = 0;
					G_statistique[G_ordinateur].profondeur = profondeur;
					ordinateur_intermediaire(G_ordinateur);
					break;

				case 2: /* niveau intermedaire */
					if (nombrePion < 14)
						profondeur = PROFONDEUR_INTERMEDIAIRE + 2;

					else if (nombrePion > LIMITE_INTERMEDIAIRE)
						profondeur = 64 - nombrePion;

					else
						profondeur = PROFONDEUR_INTERMEDIAIRE;

					G_statistique[G_ordinateur].profondeur = profondeur;
					ordinateur_expert(G_ordinateur, profondeur);
					break;

				case 3: /* niveau confirme */
					if (nombrePion < 16)
						profondeur = PROFONDEUR_CONFIRME + 2;

					else if (nombrePion > LIMITE_CONFIRME)
						profondeur = 64 - nombrePion;

					else
						profondeur = PROFONDEUR_CONFIRME;

					G_statistique[G_ordinateur].profondeur = profondeur;
					ordinateur_expert(G_ordinateur, profondeur);
					break;

				case 4: /* niveau expert */
					if (nombrePion < 14)
						profondeur = PROFONDEUR_EXPERT + 1;

					else if (nombrePion > LIMITE_EXPERT)
						profondeur = 64 - nombrePion;

					else
						profondeur = PROFONDEUR_EXPERT;

					G_statistique[G_ordinateur].profondeur = profondeur;
					ordinateur_expert(G_ordinateur, profondeur);
					break;

				default:
					break;
			}

			if (profondeur != 0)
			{
				sound(1000);
				delay(20);
				sound(50);
				delay(10);
				nosound();
			}

			/* affichage du temps de jeu de l'ordinateur */
			fin_reflexion(G_joueurCourant);

			/* calcul des statistiques */
			statistique(G_ordinateur);

			/* affichage de la nouvelle disposition */
			affiche_pions();

			/* on memorise le jeu courant */
			memorise_jeu(G_joueurCourant);

			/* on passe au joueur suivant */
			change_joueur();



		}

		else
		{ /* pas ordinateur */

			/* On affiche les coups possibles */
			if (afficheCoup || (G_ordinateur != VIDE && G_choixTypeJeu[G_ordinateur-1] == 0))
			{
				affiche_coup(G_joueurCourant, TRUE);
				afficheCoup = TRUE;
			}

			/********************************/
			/* attente appuie bouton souris */
			/********************************/
			debut_reflexion();

			mouse_attente();


			/* Raz zone d'aide en ligne */
			dialogue_aide_en_ligne("");

			/* Gestion effet appuye    */

			/* bouton coup precedent */
			if (mouse_zone(162, 173, 18, 38))
			{
				dialogue_bouton_appuye(162, 18, 11, 20);
				drwstring(1, TEXTE, FOND, "<", 164, 22);
			}

			/* bouton coup suivant */
			if (mouse_zone(178, 189, 18, 38))
			{
				dialogue_bouton_appuye(178, 18, 11, 20);
				drwstring(1, TEXTE, FOND, ">", 180, 22);
			}

			/* bouton conseil */
			if (mouse_zone(198, 260, 18, 38))
			{
				dialogue_bouton_appuye(198, 18, 62, 20);
				drwstring(1, TEXTE, FOND, "Conseil", 201, 22);
			}

			/* bouton stop */
			if (mouse_zone(440, 476, 18, 38))
			{
				dialogue_bouton_appuye(440, 18, 36, 20);
				drwstring(1, TEXTE, FOND, "Stop", 443, 22);
			}

			/* On efface les coups possibles */
			if (afficheCoup)
			{
//				afficheCoup = FALSE;
				affiche_coup(G_joueurCourant, FALSE);
			}

			/*********************************/
			/* attente relache bouton souris */
			/*********************************/
			mouse_attente_relache();

			/* bouton coup precedent */
			if (mouse_zone(162, 173, 18, 38))
				coup_precedent();

			/* bouton coup suivant */
			if (mouse_zone(178, 189, 18, 38))
			{
//				if (G_jeuIndiceCrt == G_jeuIndiceMax)
//					coupOrdinateur = TRUE;

				coup_suivant();
			}


			/* on desire arreter la partie */
			if (mouse_zone(440, 476, 18, 38))
				finJeu = 1;
//				clicStop = TRUE;

			/* on desire passer son tour */
//			if(mouse_zone(300, 350,  10,  60))
//				change_joueur();

			/* clique sur le "damier" */
			if(mouse_zone(148, 489, 75, 416))
			{
				/* on determine l'endroit ou l'on a place le pion */
				caseX = ((G_sourisX - 148) / 43) + 1;
				caseY = ((G_sourisY -  75) / 43) + 1;

				/* On verifie si l'emplacement est autorise */
				if(G_joueurCourant != G_ordinateur && retourne(G_board, caseX, caseY, TRUE, G_joueurCourant) )
				{

					/* on valide le choix et on affiche le coup joue */
					jouer_coup(caseX, caseY, G_joueurCourant);

					G_statistique[G_joueurCourant].coups.x = caseX;
					G_statistique[G_joueurCourant].coups.y = caseY;

					/* calcul des statistiques */
					statistique(G_joueurCourant);

					/* affichage de la nouvelle disposition */
					affiche_pions();

					/* on memorise le jeu courant */
					memorise_jeu(G_joueurCourant);

					/* on passe au joueur suivant */
					change_joueur();

					/* on autorise le coup pour l'ordinateur */
					coupOrdinateur = TRUE;

					afficheCoup = FALSE;



				}
				else
				{
					sound(1000);
					delay(20);
					sound(50);
					delay(20);
					sound(300);
					delay(80);
					nosound();

					if (G_joueurCourant == G_ordinateur)
						dialogue_aide_en_ligne("Vous ne pouvez pas jouer  la place d'OTHO.");
					else
					{
						sprintf(buffer, "Vous ne pouvez pas jouer en %s%s.", lettres[caseX], chiffres[caseY]);
						dialogue_aide_en_ligne(buffer);
					}
				}


			}

			/* Traitement mis volontairement a la fin pour eviter */
			/* des effets de bords */
			/* bouton conseil */
			if (mouse_zone(198, 260, 18, 38))
			{
				affiche_coup(G_joueurCourant, TRUE);
				afficheCoup = TRUE;
				conseil_coup(G_joueurCourant);
			}

			fin_reflexion(G_joueurCourant);


		} /* pas ordinateur */


		nombrePion = G_statistique[NOIR].score + G_statistique[BLANC].score;

		/* fin du jeu si les deux joueurs doivent passer leur tour */
		if (   G_statistique[BLANC].mobilite == 0
		    && G_statistique[NOIR].mobilite  == 0
		    && nombrePion != 64
		    && G_statistique[NOIR].score
		    && G_statistique[BLANC].score         )
		{
			dialogue("       FIN DU JEU       Les deux joueurs doivent    passer leur tour.");
			nombrePion = 64;
		}

		/* le joueur courant doit passer son tour */
		if (   G_statistique[G_joueurCourant].mobilite == 0
		    && G_statistique[-G_joueurCourant+3].mobilite != 0)
		{
			/* on autorise l'ordinateur de joueur */
			if (G_joueurCourant != G_ordinateur)
				coupOrdinateur = TRUE;

			/* affichage du message */
			dialogue_passe_tour(G_joueurCourant);
			change_joueur();
		}

		/* la partie est-elle terminee ? */
		if(nombrePion == 64 || !G_statistique[NOIR].score || !G_statistique[BLANC].score)
		{
			fin_jeu();    /* Congratulation au gagnant */

			/* gestion des high scores */
			high_score ();

			finJeu = 1;
		}

	} while(!finJeu); /* Fin du jeu a deux */

	/* sauvegarde de la partie jouee si au moins un coup a ete joue */
	/* et si le niveau de jeu contre l'ordinateur est different de l'initiation */
	if (G_jeuIndiceCrt > 0)
		switch(G_ordinateur)
		{
			case VIDE: /* jeu humain contre humain */
				   sauve_partie();
				   break;

			default:   /* jeu humain contre ordinateur */

				   /* sauvegarde si niveau different d'initation */
				   if (G_choixTypeJeu[G_ordinateur-1] != 0)
					sauve_partie();
				   break;
		}
}


/*************************************************************************/
/* Nom : fin_jeu                                                         */
/*                                                                       */
/* Role : Fin de la partie, un joueur a gagne ou arret de la partie      */
/*                                                                       */
/*                                                                       */
/* Entree : -                                                            */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 02/02/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/* PDB | 23/02/1997 | Simplification de l'affichage des messages en      */
/*     |            | les fonctions de dialogue                          */
/*     |            | Optimisation des traitements                       */
/*     |            |                                                    */
/*     |            |                                                    */
/*************************************************************************/


void fin_jeu ( void )
{
	int i,j;          /* variables pour les boucles */
	int pionX, pionY; /* coordonnees des pions a afficher */

	char buffer[MAX_BUFFER];
	int  gagnant  = NOIR; /* gagnant de la partie; par defaut noir */
	int  resultat;        /* reultat de la partie */


	/* On determine le gagnant */
	resultat = G_statistique[NOIR].score - G_statistique[BLANC].score;

	if (resultat > 0)
		gagnant = NOIR;

	if (resultat < 0)
		gagnant = BLANC;


	sprintf(buffer, "avec %2d points d'cart!", abs(resultat));

	/* memorisation de la zone d'ecran ou l'on affiche le message */
	blkget(220, 190, 419, 289, G_ptrFond);

	/* affichage d'un message pour la fin de la partie */
	dialogue_boite(220, 190, 419, 289);

	/* traitement particulier pour le gagnant */
	if (resultat != 0)
	{
		drwstring(1, TEXTE, FOND, "Le joueur", 225, 215);

		/* Affichage du pion gagnant */
		spritegap(44, 305, 200, G_ptrPionJeu[gagnant], G_ptrPion);

		drwstring(1, TEXTE, FOND, "a gagn", 358, 215);
		drwstring(1, TEXTE, FOND, buffer   , 230, 240);
	}

	/* traitement particulier pour un match nul */
	if (resultat == 0)
	{
		spritegap(44, 238, 217, G_ptrPionJeu[NOIR], G_ptrPion);
		spritegap(44, 360, 217, G_ptrPionJeu[BLANC], G_ptrPion);

		drwstring(1, TEXTE, FOND, "galit", 291, 233);
	}

	/* bouton OK et attente clic sur le bouton OK */
	dialogue_OK(295, 260, 345, 280);

	/* on restaure la zone d'origine */
	blkput(1, 220, 190, G_ptrFond);

	/* on remplit le damier avec une couleur de pion */
	for (i = 1; i < 9; i++)
	{
		for (j = 1; j < 9; j++)
		{
			pionX = (i-1) * 43 + 149;
			pionY = (j-1) * 43 +  76;

			if (resultat == 0)
			{
				if(gagnant == NOIR)
					gagnant = BLANC;
				else
					gagnant = NOIR;
			}

			spritegap(44, pionX, pionY, G_ptrPionJeu[gagnant], G_ptrPion);
		}
	}
}


