/* capture.c - capture current screen fo file */

/* Copyright 1997-2001 Otho team. */

/*
modification history
--------------------
15a,21oct01,pdb  based on Otho version 1.4b.
*/

/*
DESCRIPTION
This module captures the current screen to a file in
directory ./capture
*/

/* includes */

#include <dir.h>
#include <dos.h>
#include <stdio.h>

#include "include\svgacc.h"

#include "include\prototyp.h"
#include "include\global.h"

/* defines */

#define TAILLE_ECRAN_X			640
#define TAILLE_ECRAN_Y			480

/*******************************************************************************
*
* capture_ecran - capture current screen
*
* This routine allows to capture the current screen to a file
* 2 beeps signals the capture.
*
* RETURNS: N/A.
*
*/
	   
void capture_ecran ( void )
	{
	char nomFichier[]        = "capture\\ecranxxx.pcx";	/* canevas du nom des fichiers */
	int  numero = 0;		 /* numerotation des fichiers de sauvegarde */
	int  resultat;		 /* resultat de la recherche d'un nom de fichier */
	struct ffblk bloc_fichier;

	/* retour si protection ecriture active */
	if (G_protectionEcriture == TRUE)
		{
		return;
		}

	/* on cherche un nom de fichier disponible pour la capture */
	do
		{
		numero ++;
		sprintf(nomFichier,"capture\\ecran%i.pcx", numero);	  /* nom du fichier */

		/* on verifie si ce fichier existe deja */
		resultat = findfirst(nomFichier, &bloc_fichier, 0);

		} while (resultat == 0 && numero < 999);

	/* on arrete d'affecter des noms de fichier s'il existe 999 fichiers */
	/* de sauvegarde des captures, en principe nous n'atteindrons pas ce chiffre */
	if (numero == 999)
		return;

	/* Bip pour signaler le debut de la capture */
	sound(1000);
	delay(20);
	sound(50);
	delay(20);
	nosound();

	if (pcxmake (0, 0, TAILLE_ECRAN_X-1, TAILLE_ECRAN_Y-1, nomFichier) == 0)
		return;
 
	/* Bip pour signaler la fin de la capture */
	sound(1000);
	delay(20);
	sound(50);
	delay(20);
	nosound();
	}