#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>

#include "include\global.h"
#include "include\prototyp.h"
#include "include\couleur.h"


/*************************************************************************/
/* Nom : ouverture                                                       */
/*                                                                       */
/* Role : Fonction permettant d'acceder a la bibliotheque d'ouvertures   */
/*                                                                       */
/*                                                                       */
/* Entree : -                                                            */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 19/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/*     |            |                                                    */
/*************************************************************************/

void ouverture ( void )
{
	char buffer[MAX_BUFFER]; /* chaine tampon */
	char image[MAX_BUFFER]; /* Image a charger */
	int x, y;	/* coordonnees */
	int taille;
	char retour;


	/* fichier image du jeu */
	sprintf(image, "%s", "images\\otho.pcx\0");

	/* on charge l'image contenant la palette de couleur qui nous interesse */
	charge_image(image, RES640);

	/**************************/
	/* Preparation de l'ecran */
	/**************************/

//	palioauto(G_gifPalette, 0, 255, -128); /* image invisible */

//	fillscreen(0); /* ecran noir */

	video_off(); /* interdit l'affichage */

	/* dessin du contour de l'ecran */
	dialogue_boite(5, 5, 635, 440);

	/* zone d'aide en ligne */
	dialogue_boite(5, 445, 635, 475);


	/* Affichage du texte concernant le meilleurs scores */
	sprintf(buffer, "Bibliothque d'ouvertures d'%s", G_version);

	taille = strlen(buffer) * 8;
	x = (640 - taille) / 2;
	y = 20;

	drwfillbox(1, FOND, x-5, y, x+taille, y+20);
	dialogue_cadre(x-5, y, x+taille, y+20);
	drwstring(1, TEXTE_NOM, FOND, buffer, x, y+4);

	/* affichage progressif de l'ecran */
 //   palioauto(G_gifPalette, 0, 255, 100);

	video_on(); /* autorisation de l'affichage */

	/* Preparation de la bibliotheque d'ouverture */
	retour = prepare_ouverture();

	/* On travaille donc sur les ouvertures existantes */
	if (retour == OK)
	{
		dialogue_aide_en_ligne("Faites votre choix en utilisant les boutons.");

		retour = selection_ouverture();

		if (retour != -1)
		{
//			dialogue_aide_en_ligne(G_ouverture[retour].nomOuverture);

//			sprintf(buffer, "Selection : %i", retour);

//			dialogue(buffer);

			ouverture_visualise(retour);
		}
	}
}

/*************************************************************************/
/* Nom : ouverture_visualise                                             */
/*                                                                       */
/* Role : Visualisation de l'ouverture selectionnee                      */
/*                                                                       */
/*                                                                       */
/* Entree : selection : indice dans la table G_ouverture                 */
/*                                                                       */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 20/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/* PDB | 30/06/1997 | Ajout beep sur clic suivant impossible             */
/*     |            |                                                    */
/*************************************************************************/

void ouverture_visualise ( int selection )
{
	char finJeu     = 0;      /* drapeau indiquant la fin du jeu */
	int  nombrePion = 0;      /* nombre de pions places sur le damier */
	char caseX, caseY ;       /* emplacement du pion sur le damier */
	char clicStop    = FALSE; /* clique sur le bouton STOP */
	char clicSuivant = FALSE; /* clique sur le bouton > */

	char buffer[MAX_BUFFER]; /* chaine tamporaire */

	typeStructureCoups coupsOuverture[NOMBRE_COUPS]; /* les coups de l'ouverture */
	int  couleurJoueur[NOMBRE_COUPS]; /* la couleur de joueur jouant le coup */

	char nombreCoups; /* le nombre de coup de l'ouverture */
	char coupsCourant = 0;

	char numeroCoups = 0; /* numero du coup */


	/* On determine le nombre de coups de l'ouverture */
	/* et on prepare la table des coups a jouer */
	nombreCoups = 0;

	while (isalpha(G_ouverture[selection].coups[nombreCoups].x))
	{
		if (isupper(G_ouverture[selection].coups[nombreCoups].x))
		{
			couleurJoueur[nombreCoups] = NOIR;
			coupsOuverture[nombreCoups].x = G_ouverture[selection].coups[nombreCoups].x - 'A' + 1;
			coupsOuverture[nombreCoups].y = G_ouverture[selection].coups[nombreCoups].y - '0';
		}
		else if (islower(G_ouverture[selection].coups[nombreCoups].x))
		{
			couleurJoueur[nombreCoups] = BLANC;
			coupsOuverture[nombreCoups].x = G_ouverture[selection].coups[nombreCoups].x - 'a' + 1;
			coupsOuverture[nombreCoups].y = G_ouverture[selection].coups[nombreCoups].y - '0';
		}
//		sprintf(buffer, "x:%i y:%i pion:%i coups:%i", coupsOuverture[nombreCoups].x, coupsOuverture[nombreCoups].y, couleurJoueur[nombreCoups], nombreCoups);
//		dialogue(buffer);
		nombreCoups++;
	}


	/* on initialise l'environnement de jeu */
	initialise_ecran_jeu();

	/* initialisation du jeu */
	G_joueurCourant = NOIR;
	G_ordinateur = VIDE;

	G_choixTypeJeu[0] = 0;
	G_choixTypeJeu[1] = 0;

	initialise_jeu();

	/* bouton conseil inactif */
	drwstring(1, TEXTE_INACTIF, FOND, "Conseil", 201, 22);

	sprintf(buffer, "%s", G_ouverture[selection].nomOuverture);

	/* debut du jeu */
	statistique(NOIR);

	/* Nom des joueurs pour les ouvertures */
	sprintf(G_nom[NOIR] , "NOIR" );
	sprintf(G_nom[BLANC], "BLANC");

	/* affichage des Noms des joueurs */
	drwstring(1, TEXTE_NOM, FOND, G_nom[NOIR],   20+(90-strlen(G_nom[NOIR])*8)/2, 75);
	drwstring(1, TEXTE_NOM, FOND, G_nom[BLANC], 530+(90-strlen(G_nom[BLANC])*8)/2, 75);


	/* Tant que l'on ne quitte pas le jeu */
	do
	{
		/* tableau de commande a l'etat normal */
		initialise_tableau_commande();

		/* bouton conseil inactif */
		drwstring(1, TEXTE_INACTIF, FOND, "Conseil", 201, 22);

		dialogue_aide_en_ligne(buffer);

		if (clicSuivant)
		{
			clicSuivant = FALSE;

			if (coupsCourant < nombreCoups) /* on peut avancer */
			{

				/* On determine le coup suivant */
				if (G_joueurCourant == couleurJoueur[coupsCourant])
				{
					/* coups a jouer */
					caseX = coupsOuverture[coupsCourant].x;
					caseY = coupsOuverture[coupsCourant].y;

					retourne(G_board, caseX, caseY, TRUE, G_joueurCourant);

					/* on affiche le coup joue */
					jouer_coup(caseX, caseY, G_joueurCourant);

					/* on inclus le coup dans les statistiques */
					G_statistique[G_joueurCourant].coups.x = caseX;
					G_statistique[G_joueurCourant].coups.y = caseY;

					/* on passe au coup suivant */
					coupsCourant++;

					/* on recalcule les statistiques */
					statistique(G_joueurCourant);

					/* on affiche la nouvelle disposition des pions */
					affiche_pions();

					/* on memorise le jeu courant */
					memorise_jeu(G_joueurCourant);

					/* on passe au joueur suivant */
					change_joueur();

				}
			}
			else
			{
				sprintf(buffer, "Dernier coup de l'ouverture atteint.");
				sound(1000);
				delay(20);
				sound(50);
				delay(10);
				nosound();
			}

		} /* fin si clicSuivant */


		/* affichage des coups possibles */
		affiche_coup(G_joueurCourant, TRUE);

		/********************************/
		/* attente appuie bouton souris */
		/********************************/
		mouse_attente();

		/* Raz zone d'aide en ligne */

		dialogue_aide_en_ligne("");

		/* Gestion effet appuye    */

		/* bouton coup precedent */
		if (mouse_zone(162, 173, 18, 38))
		{
			dialogue_bouton_appuye(162, 18, 11, 20);
			drwstring(1, TEXTE, FOND, "<", 164, 22);
		}

		/* bouton coup suivant */
		if (mouse_zone(178, 189, 18, 38))
		{
			dialogue_bouton_appuye(178, 18, 11, 20);
			drwstring(1, TEXTE, FOND, ">", 180, 22);
		}

		/* bouton stop */
		if (mouse_zone(440, 476, 18, 38))
		{
			dialogue_bouton_appuye(440, 18, 36, 20);
			drwstring(1, TEXTE, FOND, "Stop", 443, 22);
		}

		/*********************************/
		/* attente relache bouton souris */
		/*********************************/
		mouse_attente_relache();

		/* On efface les coups possibles */
		affiche_coup(G_joueurCourant, FALSE);

		/* bouton coup precedent */
		if (mouse_zone(162, 173, 18, 38))
		{
			coup_precedent();

			if (numeroCoups != 0)
			{
				numeroCoups--;
				sprintf(buffer,"Coup courant de l'ouverture : %i/%i", numeroCoups, nombreCoups);
			}
			else
			{
				sprintf(buffer, "Vous tes au dbut de l'ouverture.");
			}
		}

		/* bouton coup suivant */
		if (mouse_zone(178, 189, 18, 38))
		{
			if (G_jeuIndiceCrt == G_jeuIndiceMax)
				clicSuivant = TRUE;
			else
			    coup_suivant();

			if (numeroCoups < nombreCoups)
			{
				numeroCoups++;
				sprintf(buffer,"Coup courant de l'ouverture : %i/%i", numeroCoups, nombreCoups);
			}
		}


		/* on desire arreter la partie */
		if (mouse_zone(440, 476, 18, 38))
			clicStop = TRUE;

		/* la partie est-elle terminee ? */
		nombrePion = G_statistique[NOIR].score + G_statistique[BLANC].score;

		if(nombrePion == 64 || !G_statistique[NOIR].score || !G_statistique[BLANC].score || clicStop)
		{
			finJeu = 1;
		}

	} while(!finJeu); /* Fin du jeu */
}


/*************************************************************************/
/* Nom : creation_bibliotheque_ouverture                                 */
/*                                                                       */
/* Role : Creation du fichier des ouvertures                             */
/*                                                                       */
/*                                                                       */
/* Entree : fichierTxt : fichier texte en entree                         */
/*          fichierDat : fichier data en sortie (format binaire)         */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 19/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/*     |            |                                                    */
/*************************************************************************/

void creation_bibliotheque_ouverture ( FILE *fichierTxt, FILE *fichierDat)
{
	char tampon[255];                 /* tampon pour la lecture d'une ligne */
	typeStructureOuverture ouverture; /* ligne pour la sortie */
	int caractere;
	int caractereNom;
	int coups;


	while ( fgets( tampon, 255, fichierTxt) != NULL )
	{
		/* different d'une ligne vide, de l'indicateur de commentaire */
		if ( !isspace(tampon[0]) && tampon[0] != '*' )
		{
			/* on initialise la structure ouverture */
			for (coups = 0; coups < NOMBRE_COUPS; coups ++)
			{
				ouverture.coups[coups].x = 0x00;
				ouverture.coups[coups].y = 0x00;

			}

			/* decodage de la premiere partie du fichier : coups */
			caractere = 0;
			coups = 0;
			while ( !isspace(tampon[caractere]) && tampon[caractere] != NULL)
			{
				if (isalpha(tampon[caractere]))
					ouverture.coups[coups].x = tampon[caractere];

				if (isdigit(tampon[caractere]))
				{
					ouverture.coups[coups].y = tampon[caractere];
					coups++;
				}
				caractere++;

			}

			/* suppression des caracteres blancs, tabulation... */
			while (isspace(tampon[caractere]))
				caractere++;

			/* decodage de la deuxieme partie du fichier : nom de l'ouverture */
			caractereNom = 0;
			while ( !iscntrl(tampon[caractere]) && caractereNom < 80)
			{
				ouverture.nomOuverture[caractereNom] = tampon[caractere];

				caractereNom++;
				caractere++;

			}

			ouverture.nomOuverture[caractereNom] = 0x00;

			/* Ecriture vers la sortie */
			fwrite(&ouverture, sizeof(ouverture), 1, fichierDat);


		}
	}
}

/*************************************************************************/
/* Nom : prepare_ouverture                                               */
/*                                                                       */
/* Role : Fonction permettant de verifier l'existance des fichiers de    */
/*        donnes et de creer eventuellement la bibliotheque              */
/*                                                                       */
/*                                                                       */
/* Entree : -                                                            */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 19/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/* PDB | 10/08/1997 | Creation ouvertur.dat impossible si protection     */
/*     |            | ecriture active                                                   */
/*     |            |                                                    */
/*************************************************************************/

char prepare_ouverture ( void )
{
	char nomFichierTxt[] = "data\\ouvertur.txt"; /* nom du fichier en entree */
	char nomFichierDat[] = "data\\ouvertur.dat"; /* nom du fichier resultat  */

	FILE *fichierTxt; /* le fichier en entree */
	FILE *fichierDat; /* le fichier en sortie */


	/* Format du fichier TXT  :                                  */
	/* ------------------------                                  */
	/* Sur une meme ligne on trouve les champs ecrits ci-dessous */
	/* . coups : coups du style C4f5H8, la lettre en majuscule   */
	/*           signale un coup du joueur noir                  */
	/* . separateur : blanc ou tabulation                        */
	/* . nom de l'ouverture                                      */
	/*                                                           */
	/* Nota : un * en premier caractere signale une ligne de     */
	/*        commentaires                                       */
	/*                                                           */
	/* Format du fichier DAT  :                                  */
	/* ------------------------                                  */
	/* base sur le type typeStructureOuverture                   */
	/*                                                           */

	/* On verifie l'existence du fichier DAT */
	/* s'il n'existe pas on le creer a partir du fichier txt s'il existe */
	if ((fichierDat = fopen(nomFichierDat, "rb")) == NULL)
	{
		if ((fichierTxt = fopen(nomFichierTxt, "rt")) == NULL)
		{
			dialogue_aide_en_ligne("Le fichier des ouvertures n'existe pas");
			return NOK;
		}
		else /* creation */
		{
			dialogue_aide_en_ligne("Preparation de la bibliotheque...");


			/* Pas de creation si Protection active */
			if (G_protectionEcriture == TRUE)
			{
				dialogue("Impossible de crer les ouvertures");
				return NOK;
			}

			/* creation du fichier Dat */

			if ((fichierDat = fopen(nomFichierDat, "wb")) == NULL)
			{
				dialogue_aide_en_ligne("Desol, un problme est survenu lors de la preparation.");
				return NOK;
			}
			else
			{
				creation_bibliotheque_ouverture(fichierTxt, fichierDat);

				fclose(fichierDat);
			}

			fclose(fichierTxt);
		}

	}
	return OK;

}

/*************************************************************************/
/* Nom : affiche_page_ouverture                                          */
/*                                                                       */
/* Role : Affiche les ouvertures correspondant a une page                */
/*                                                                       */
/*                                                                       */
/* Entree : page : page a afficher                                       */
/*          fichierOuverture : fichier contenant les ouvertures          */
/*                                                                       */
/* Sortie : nombre max de ligne de l'ecran                               */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 19/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/*************************************************************************/

char affiche_page_ouverture ( char page, FILE * fichierOuverture )
{
	char ligne = 0;
	char boucle;

	/* on efface la page courante */
	dialogue_zone_saisie(20, 60, 60, 28);

	/* on se positionne en debut de fichier */
	fseek(fichierOuverture, 0, SEEK_SET);

	/* on se place a la page desire */
	while (page--)
		fread(G_ouverture, sizeof(typeStructureOuverture), 28, fichierOuverture);

	/* Lecture de la page qui nous interresse et affichage */
	/* Lecture de 28 lignes sinon ce qu'il reste */
	ligne = fread(G_ouverture, sizeof(typeStructureOuverture), 28, fichierOuverture);

	/* affichage des lignes lues */
	for (boucle = 0; boucle < ligne; boucle ++)
		drwstring(1, TEXTE, TEXTE_FOND, G_ouverture[boucle].nomOuverture, 20+2, 60+boucle*13);

	/* retourne le nombre de lignes pour l'ecran */
	return ligne;
}

/*************************************************************************/
/* Nom : ouverture_gestion_souris                                        */
/*                                                                       */
/* Role : Gestion de la souris pour les ouvertures                       */
/*                                                                       */
/*                                                                       */
/* Entree : nombrePageMax : nombre de page a afficher au maximum         */
/*          fichierDat    : fichier des ouvertures                       */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 19/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/* PDB | 29/06/1997 | Emplacement des boutons parametrables              */
/*     |            |                                                    */
/* PDB | 30/06/1997 | Modification taille boutons + et -                 */
/*     |            |                                                    */
/*************************************************************************/

char ouverture_gestion_souris ( int nombrePageMax, FILE *fichierDat )
{
	char pageCourante  = 0; /* page courante a l'ecran */
	char pageMemoire   = 1; /* memorisation de la page courante */
	char clicAnnuler   = FALSE;
	char clicOk        = FALSE;
	char buffer[MAX_BUFFER]; /* chaine tampon */
	int  selectionLigne;     /* ligne selectionnee */
	int  nombreMaxLigne;

	struct _coordonnees
	{
		int x;
		int y;
	} pagePlus, pageMoins, lignePlus, ligneMoins, boutonOK, boutonAnnuler;

	struct _taille
	{
		char x;
		char y;
	} taillePage, tailleLigne, tailleBoutonOK, tailleBoutonAnnuler;

	pagePlus.x    = 546;
	pagePlus.y    =  80;
	pageMoins.x   = 520;
	pageMoins.y   =  80;
	taillePage.x  =  19;
	taillePage.y  =  20;

	lignePlus.x   = 546;
	lignePlus.y   = 140;
	ligneMoins.x  = 520;
	ligneMoins.y  = 140;
	tailleLigne.x =  19;
	tailleLigne.y =  20;

	boutonOK.x       = 520;
	boutonOK.y       = 400;
	tailleBoutonOK.x =  24;
	tailleBoutonOK.y =  20;

	boutonAnnuler.x       = 555;
	boutonAnnuler.y       = 400;
	tailleBoutonAnnuler.x =  64;
	tailleBoutonAnnuler.y =  20;

	while (!clicAnnuler && !clicOk) /* tant que l'on clique pas sur sortir */
	{
		/* affichage de la page courante si nouvelle page demandee */
		if (pageCourante != pageMemoire)
		{
			nombreMaxLigne = affiche_page_ouverture(pageCourante, fichierDat);
			pageMemoire = pageCourante;

			selectionLigne = -1; /* pas de ligne selectionnee */

			/* Pagination de l'ecran */
			sprintf(buffer, "%2i/%2i", pageCourante+1, nombrePageMax+1);
			dialogue_cadre(570, 20, 570+56, 20+16);
			drwstring(1, TEXTE, FOND, buffer, 578, 20+2);
		}

		/* Affichage texte commandes */
		drwstring(1, TEXTE, FOND, "Choix page :", pageMoins.x, pageMoins.y-20);
		drwstring(1, TEXTE, FOND, "Choix ligne :", ligneMoins.x, ligneMoins.y-20);

		/* Page precedente */
		dialogue_bouton_relache(pageMoins.x, pageMoins.y, taillePage.x, taillePage.y);
		drwstring(1, TEXTE, FOND, "<<", pageMoins.x+2, pageMoins.y+4);

		/* Page suivante */
		dialogue_bouton_relache(pagePlus.x, pagePlus.y, taillePage.x, taillePage.y);
		drwstring(1, TEXTE, FOND, ">>", pagePlus.x+2, pagePlus.y+4);

		/* ligne precedente */
		dialogue_bouton_relache(ligneMoins.x, ligneMoins.y, tailleLigne.x, tailleLigne.y);
		drwstring(1, TEXTE, FOND, "-", ligneMoins.x+6, ligneMoins.y+4);

		/* ligne suivante */
		dialogue_bouton_relache(lignePlus.x, lignePlus.y, tailleLigne.x, tailleLigne.y);
		drwstring(1, TEXTE, FOND, "+", lignePlus.x+6, lignePlus.y+4);

		/* Bouton OK */
		dialogue_bouton_relache(boutonOK.x, boutonOK.y, tailleBoutonOK.x, tailleBoutonOK.y);
		drwstring(1, TEXTE, FOND, "OK", boutonOK.x+4, boutonOK.y+4);

		/* Bouton Annuler */
		dialogue_bouton_relache(boutonAnnuler.x, boutonAnnuler.y, tailleBoutonAnnuler.x, tailleBoutonAnnuler.y);
		drwstring(1, TEXTE, FOND, "Annuler", boutonAnnuler.x+4, boutonAnnuler.y+4);

		/* on rend les boutons inactifs en fonction de la page courante */
		if (pageCourante == 0)
			drwstring(1, TEXTE, FOND, "<<", pageMoins.x+2, pageMoins.y+4);

		else if (pageCourante == nombrePageMax)
			drwstring(1, TEXTE, FOND, ">>", pagePlus.x+2, pagePlus.y+4);

		/************************************/
		/* attente appui clic bouton souris */
		/************************************/
		mouse_attente();

		/* effet appuye bouton */

		/* bouton page precedente */
		if (mouse_zone(pageMoins.x, pageMoins.x+taillePage.x, pageMoins.y, pageMoins.y+taillePage.y) && pageCourante > 0)
		{
			dialogue_bouton_appuye(pageMoins.x, pageMoins.y, taillePage.x, taillePage.y);
			drwstring(1, TEXTE, FOND, "<<", pageMoins.x+2, pageMoins.y+4);
		}

		/* bouton page suivante */
		if (mouse_zone(pagePlus.x, pagePlus.x+taillePage.x, pagePlus.y, pagePlus.y+taillePage.y) && pageCourante < nombrePageMax)
		{
			dialogue_bouton_appuye(pagePlus.x, pagePlus.y, taillePage.x, taillePage.y);
			drwstring(1, TEXTE, FOND, ">>", pagePlus.x+2, pagePlus.y+4);
		}

		/* ligne precedente */
		if (mouse_zone(ligneMoins.x, ligneMoins.x + tailleLigne.x, ligneMoins.y, ligneMoins.y + tailleLigne.y))
		{
			dialogue_bouton_appuye(ligneMoins.x, ligneMoins.y, tailleLigne.x, tailleLigne.y);
			drwstring(1, TEXTE, FOND, "-", ligneMoins.x+6, ligneMoins.y+4);
		}

		/* ligne suivante */
		if (mouse_zone(lignePlus.x, lignePlus.x + tailleLigne.x, lignePlus.y, lignePlus.y + tailleLigne.y))
		{
			dialogue_bouton_appuye(lignePlus.x, lignePlus.y, tailleLigne.x, tailleLigne.y);
			drwstring(1, TEXTE, FOND, "+", lignePlus.x+6, lignePlus.y+4);
		}

		/* Bouton OK */
		if (mouse_zone(boutonOK.x, boutonOK.x + tailleBoutonOK.x, boutonOK.y, boutonOK.y + tailleBoutonOK.y))
		{
			dialogue_bouton_appuye(boutonOK.x, boutonOK.y, tailleBoutonOK.x, tailleBoutonOK.y);
			drwstring(1, TEXTE, FOND, "OK", boutonOK.x+4, boutonOK.y+4);
		}

		/* Bouton Annuler */
		if (mouse_zone(boutonAnnuler.x, boutonAnnuler.x + tailleBoutonAnnuler.x, boutonAnnuler.y, boutonAnnuler.y + tailleBoutonAnnuler.y))
		{
			dialogue_bouton_appuye(boutonAnnuler.x, boutonAnnuler.y, tailleBoutonAnnuler.x, tailleBoutonAnnuler.y);
			drwstring(1, TEXTE, FOND, "Annuler", boutonAnnuler.x+4, boutonAnnuler.y+4);
		}

		/**************************/
		/* attente relache bouton */
		/**************************/
		mouse_attente_relache();

		/*********************/
		/* gestion des choix */
		/*********************/

		/* bouton page precedente */
		if (mouse_zone(pageMoins.x, pageMoins.x+taillePage.x, pageMoins.y, pageMoins.y+taillePage.y) && pageCourante > 0)
		{
			pageCourante--;
		}

		/* bouton page suivante */
		if (mouse_zone(pagePlus.x, pagePlus.x+taillePage.x, pagePlus.y, pagePlus.y+taillePage.y) && pageCourante < nombrePageMax)
		{
			pageCourante++;
		}

		/* ligne precedente */
		if (mouse_zone(ligneMoins.x, ligneMoins.x + tailleLigne.x, ligneMoins.y, ligneMoins.y + tailleLigne.y))
		{
			if (selectionLigne > 0)
			{
				/* Mise a l'etat normal de la precedente selection */
				drwstring(1, TEXTE, TEXTE_FOND, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

				/* on affiche la nouvelle selection */
				selectionLigne--;

				drwstring(1, TEXTE_FOND, TEXTE, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);
			}
			else if (selectionLigne == 0)
			{
				/* Mise a l'etat normal de la precedente selection */
				drwstring(1, TEXTE, TEXTE_FOND, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

				/* on affiche la nouvelle selection */
				selectionLigne = nombreMaxLigne - 1;

				drwstring(1, TEXTE_FOND, TEXTE, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

			}
			else if (selectionLigne == -1)
			{
				/* on affiche la nouvelle selection */
				selectionLigne = nombreMaxLigne - 1;

				drwstring(1, TEXTE_FOND, TEXTE, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);
			}

		}

		/* ligne suivante */
		if (mouse_zone(lignePlus.x, lignePlus.x + tailleLigne.x, lignePlus.y, lignePlus.y + tailleLigne.y))
		{
			if (selectionLigne < nombreMaxLigne - 1)
			{
				if (selectionLigne != -1)
					/* Mise a l'etat normal de la precedente selection */
					drwstring(1, TEXTE, TEXTE_FOND, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

				/* on affiche la nouvelle selection */
				selectionLigne++;

				drwstring(1, TEXTE_FOND, TEXTE, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

			}
			else if (selectionLigne == nombreMaxLigne - 1)
			{
				/* Mise a l'etat normal de la precedente selection */
				drwstring(1, TEXTE, TEXTE_FOND, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

				/* on affiche la nouvelle selection */
				selectionLigne = 0;

				drwstring(1, TEXTE_FOND, TEXTE, G_ouverture[selectionLigne].nomOuverture, 20+2, 60+selectionLigne*13);

			}
		}

		/* Bouton OK */
		if (mouse_zone(boutonOK.x, boutonOK.x + tailleBoutonOK.x, boutonOK.y, boutonOK.y + tailleBoutonOK.y))
			clicOk = TRUE;

		/* Bouton Annuler */
		if (mouse_zone(boutonAnnuler.x, boutonAnnuler.x + tailleBoutonAnnuler.x, boutonAnnuler.y, boutonAnnuler.y + tailleBoutonAnnuler.y))
			clicAnnuler = TRUE;
	}

	if (clicAnnuler == TRUE)
		selectionLigne = -1;

	return selectionLigne;

}


/*************************************************************************/
/* Nom : selection_ouverture                                             */
/*                                                                       */
/* Role : Selection d'une ouverture                                      */
/*                                                                       */
/*                                                                       */
/* Entree : -                                                            */
/* Sortie : -                                                            */
/*                                                                       */
/* ===================================================================== */
/* Nom | Date       | Description                                        */
/* ----+------------+--------------------------------------------------- */
/* PDB | 19/05/1997 | Creation de la fonction.                           */
/*     |            |                                                    */
/*     |            |                                                    */
/*************************************************************************/

char selection_ouverture ( void )
{
	char nomFichierDat[] = "data\\ouvertur.dat"; /* nom du fichier des ouvertures  */
	typeStructureOuverture ouverture;
	int nombreMaxLigne = 0;
	int nombreMaxPage;
	char ligneSelectionnee = -1 ;

	FILE *fichierDat; /* le fichier des ouvertures */


	if ((fichierDat = fopen(nomFichierDat, "rb")) == NULL)
	{
		dialogue_aide_en_ligne("Problmes  l'ouverture de la bibliothque.");
	}
	else
	{
		/* on determine le nombre max de ligne et de page max */

		/* on se positionne en debut de fichier */
		fseek(fichierDat, 0, SEEK_SET);

		while (fread(&ouverture, sizeof(ouverture), 1, fichierDat))
			nombreMaxLigne++;

		/* calcul du nombre de page */
		nombreMaxPage = nombreMaxLigne / 28;

		/* gestion souris pour le choix */
		ligneSelectionnee = ouverture_gestion_souris ( nombreMaxPage, fichierDat );

		fclose(fichierDat);


	}

	return (ligneSelectionnee);
}

